/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasFlexClusterConfig extends cdktf.TerraformMetaArguments {
    /**
    * Human-readable label that identifies the instance.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.37.0/docs/data-sources/flex_cluster#name DataMongodbatlasFlexCluster#name}
    */
    readonly name: string;
    /**
    * Unique 24-hexadecimal character string that identifies the project.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.37.0/docs/data-sources/flex_cluster#project_id DataMongodbatlasFlexCluster#project_id}
    */
    readonly projectId: string;
}
export interface DataMongodbatlasFlexClusterBackupSettings {
}
export declare function dataMongodbatlasFlexClusterBackupSettingsToTerraform(struct?: DataMongodbatlasFlexClusterBackupSettings): any;
export declare function dataMongodbatlasFlexClusterBackupSettingsToHclTerraform(struct?: DataMongodbatlasFlexClusterBackupSettings): any;
export declare class DataMongodbatlasFlexClusterBackupSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasFlexClusterBackupSettings | undefined;
    set internalValue(value: DataMongodbatlasFlexClusterBackupSettings | undefined);
    get enabled(): cdktf.IResolvable;
}
export interface DataMongodbatlasFlexClusterConnectionStrings {
}
export declare function dataMongodbatlasFlexClusterConnectionStringsToTerraform(struct?: DataMongodbatlasFlexClusterConnectionStrings): any;
export declare function dataMongodbatlasFlexClusterConnectionStringsToHclTerraform(struct?: DataMongodbatlasFlexClusterConnectionStrings): any;
export declare class DataMongodbatlasFlexClusterConnectionStringsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasFlexClusterConnectionStrings | undefined;
    set internalValue(value: DataMongodbatlasFlexClusterConnectionStrings | undefined);
    get standard(): string;
    get standardSrv(): string;
}
export interface DataMongodbatlasFlexClusterProviderSettings {
}
export declare function dataMongodbatlasFlexClusterProviderSettingsToTerraform(struct?: DataMongodbatlasFlexClusterProviderSettings): any;
export declare function dataMongodbatlasFlexClusterProviderSettingsToHclTerraform(struct?: DataMongodbatlasFlexClusterProviderSettings): any;
export declare class DataMongodbatlasFlexClusterProviderSettingsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasFlexClusterProviderSettings | undefined;
    set internalValue(value: DataMongodbatlasFlexClusterProviderSettings | undefined);
    get backingProviderName(): string;
    get diskSizeGb(): number;
    get providerName(): string;
    get regionName(): string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.37.0/docs/data-sources/flex_cluster mongodbatlas_flex_cluster}
*/
export declare class DataMongodbatlasFlexCluster extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_flex_cluster";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasFlexCluster resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasFlexCluster to import
    * @param importFromId The id of the existing DataMongodbatlasFlexCluster that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.37.0/docs/data-sources/flex_cluster#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasFlexCluster to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.37.0/docs/data-sources/flex_cluster mongodbatlas_flex_cluster} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasFlexClusterConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasFlexClusterConfig);
    private _backupSettings;
    get backupSettings(): DataMongodbatlasFlexClusterBackupSettingsOutputReference;
    get clusterType(): string;
    private _connectionStrings;
    get connectionStrings(): DataMongodbatlasFlexClusterConnectionStringsOutputReference;
    get createDate(): string;
    get id(): string;
    get mongoDbVersion(): string;
    private _name?;
    get name(): string;
    set name(value: string);
    get nameInput(): string | undefined;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    private _providerSettings;
    get providerSettings(): DataMongodbatlasFlexClusterProviderSettingsOutputReference;
    get stateName(): string;
    private _tags;
    get tags(): cdktf.StringMap;
    get terminationProtectionEnabled(): cdktf.IResolvable;
    get versionReleaseSystem(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
