/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasResourcePoliciesConfig extends cdktf.TerraformMetaArguments {
    /**
    * Unique 24-hexadecimal digit string that identifies the organization that contains your projects. Use the [/orgs](#tag/Organizations/operation/listOrganizations) endpoint to retrieve all organizations to which the authenticated user has access.
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.37.0/docs/data-sources/resource_policies#org_id DataMongodbatlasResourcePolicies#org_id}
    */
    readonly orgId: string;
}
export interface DataMongodbatlasResourcePoliciesResourcePoliciesCreatedByUser {
}
export declare function dataMongodbatlasResourcePoliciesResourcePoliciesCreatedByUserToTerraform(struct?: DataMongodbatlasResourcePoliciesResourcePoliciesCreatedByUser): any;
export declare function dataMongodbatlasResourcePoliciesResourcePoliciesCreatedByUserToHclTerraform(struct?: DataMongodbatlasResourcePoliciesResourcePoliciesCreatedByUser): any;
export declare class DataMongodbatlasResourcePoliciesResourcePoliciesCreatedByUserOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasResourcePoliciesResourcePoliciesCreatedByUser | undefined;
    set internalValue(value: DataMongodbatlasResourcePoliciesResourcePoliciesCreatedByUser | undefined);
    get id(): string;
    get name(): string;
}
export interface DataMongodbatlasResourcePoliciesResourcePoliciesLastUpdatedByUser {
}
export declare function dataMongodbatlasResourcePoliciesResourcePoliciesLastUpdatedByUserToTerraform(struct?: DataMongodbatlasResourcePoliciesResourcePoliciesLastUpdatedByUser): any;
export declare function dataMongodbatlasResourcePoliciesResourcePoliciesLastUpdatedByUserToHclTerraform(struct?: DataMongodbatlasResourcePoliciesResourcePoliciesLastUpdatedByUser): any;
export declare class DataMongodbatlasResourcePoliciesResourcePoliciesLastUpdatedByUserOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasResourcePoliciesResourcePoliciesLastUpdatedByUser | undefined;
    set internalValue(value: DataMongodbatlasResourcePoliciesResourcePoliciesLastUpdatedByUser | undefined);
    get id(): string;
    get name(): string;
}
export interface DataMongodbatlasResourcePoliciesResourcePoliciesPolicies {
}
export declare function dataMongodbatlasResourcePoliciesResourcePoliciesPoliciesToTerraform(struct?: DataMongodbatlasResourcePoliciesResourcePoliciesPolicies): any;
export declare function dataMongodbatlasResourcePoliciesResourcePoliciesPoliciesToHclTerraform(struct?: DataMongodbatlasResourcePoliciesResourcePoliciesPolicies): any;
export declare class DataMongodbatlasResourcePoliciesResourcePoliciesPoliciesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasResourcePoliciesResourcePoliciesPolicies | undefined;
    set internalValue(value: DataMongodbatlasResourcePoliciesResourcePoliciesPolicies | undefined);
    get body(): string;
    get id(): string;
}
export declare class DataMongodbatlasResourcePoliciesResourcePoliciesPoliciesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasResourcePoliciesResourcePoliciesPoliciesOutputReference;
}
export interface DataMongodbatlasResourcePoliciesResourcePolicies {
}
export declare function dataMongodbatlasResourcePoliciesResourcePoliciesToTerraform(struct?: DataMongodbatlasResourcePoliciesResourcePolicies): any;
export declare function dataMongodbatlasResourcePoliciesResourcePoliciesToHclTerraform(struct?: DataMongodbatlasResourcePoliciesResourcePolicies): any;
export declare class DataMongodbatlasResourcePoliciesResourcePoliciesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasResourcePoliciesResourcePolicies | undefined;
    set internalValue(value: DataMongodbatlasResourcePoliciesResourcePolicies | undefined);
    private _createdByUser;
    get createdByUser(): DataMongodbatlasResourcePoliciesResourcePoliciesCreatedByUserOutputReference;
    get createdDate(): string;
    get description(): string;
    get id(): string;
    private _lastUpdatedByUser;
    get lastUpdatedByUser(): DataMongodbatlasResourcePoliciesResourcePoliciesLastUpdatedByUserOutputReference;
    get lastUpdatedDate(): string;
    get name(): string;
    get orgId(): string;
    private _policies;
    get policies(): DataMongodbatlasResourcePoliciesResourcePoliciesPoliciesList;
    get version(): string;
}
export declare class DataMongodbatlasResourcePoliciesResourcePoliciesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasResourcePoliciesResourcePoliciesOutputReference;
}
export interface DataMongodbatlasResourcePoliciesResultsCreatedByUser {
}
export declare function dataMongodbatlasResourcePoliciesResultsCreatedByUserToTerraform(struct?: DataMongodbatlasResourcePoliciesResultsCreatedByUser): any;
export declare function dataMongodbatlasResourcePoliciesResultsCreatedByUserToHclTerraform(struct?: DataMongodbatlasResourcePoliciesResultsCreatedByUser): any;
export declare class DataMongodbatlasResourcePoliciesResultsCreatedByUserOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasResourcePoliciesResultsCreatedByUser | undefined;
    set internalValue(value: DataMongodbatlasResourcePoliciesResultsCreatedByUser | undefined);
    get id(): string;
    get name(): string;
}
export interface DataMongodbatlasResourcePoliciesResultsLastUpdatedByUser {
}
export declare function dataMongodbatlasResourcePoliciesResultsLastUpdatedByUserToTerraform(struct?: DataMongodbatlasResourcePoliciesResultsLastUpdatedByUser): any;
export declare function dataMongodbatlasResourcePoliciesResultsLastUpdatedByUserToHclTerraform(struct?: DataMongodbatlasResourcePoliciesResultsLastUpdatedByUser): any;
export declare class DataMongodbatlasResourcePoliciesResultsLastUpdatedByUserOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string);
    get internalValue(): DataMongodbatlasResourcePoliciesResultsLastUpdatedByUser | undefined;
    set internalValue(value: DataMongodbatlasResourcePoliciesResultsLastUpdatedByUser | undefined);
    get id(): string;
    get name(): string;
}
export interface DataMongodbatlasResourcePoliciesResultsPolicies {
}
export declare function dataMongodbatlasResourcePoliciesResultsPoliciesToTerraform(struct?: DataMongodbatlasResourcePoliciesResultsPolicies): any;
export declare function dataMongodbatlasResourcePoliciesResultsPoliciesToHclTerraform(struct?: DataMongodbatlasResourcePoliciesResultsPolicies): any;
export declare class DataMongodbatlasResourcePoliciesResultsPoliciesOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasResourcePoliciesResultsPolicies | undefined;
    set internalValue(value: DataMongodbatlasResourcePoliciesResultsPolicies | undefined);
    get body(): string;
    get id(): string;
}
export declare class DataMongodbatlasResourcePoliciesResultsPoliciesList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasResourcePoliciesResultsPoliciesOutputReference;
}
export interface DataMongodbatlasResourcePoliciesResults {
}
export declare function dataMongodbatlasResourcePoliciesResultsToTerraform(struct?: DataMongodbatlasResourcePoliciesResults): any;
export declare function dataMongodbatlasResourcePoliciesResultsToHclTerraform(struct?: DataMongodbatlasResourcePoliciesResults): any;
export declare class DataMongodbatlasResourcePoliciesResultsOutputReference extends cdktf.ComplexObject {
    private isEmptyObject;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param complexObjectIndex the index of this item in the list
    * @param complexObjectIsFromSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, complexObjectIndex: number, complexObjectIsFromSet: boolean);
    get internalValue(): DataMongodbatlasResourcePoliciesResults | undefined;
    set internalValue(value: DataMongodbatlasResourcePoliciesResults | undefined);
    private _createdByUser;
    get createdByUser(): DataMongodbatlasResourcePoliciesResultsCreatedByUserOutputReference;
    get createdDate(): string;
    get description(): string;
    get id(): string;
    private _lastUpdatedByUser;
    get lastUpdatedByUser(): DataMongodbatlasResourcePoliciesResultsLastUpdatedByUserOutputReference;
    get lastUpdatedDate(): string;
    get name(): string;
    get orgId(): string;
    private _policies;
    get policies(): DataMongodbatlasResourcePoliciesResultsPoliciesList;
    get version(): string;
}
export declare class DataMongodbatlasResourcePoliciesResultsList extends cdktf.ComplexList {
    protected terraformResource: cdktf.IInterpolatingParent;
    protected terraformAttribute: string;
    protected wrapsSet: boolean;
    /**
    * @param terraformResource The parent resource
    * @param terraformAttribute The attribute on the parent resource this class is referencing
    * @param wrapsSet whether the list is wrapping a set (will add tolist() to be able to access an item via an index)
    */
    constructor(terraformResource: cdktf.IInterpolatingParent, terraformAttribute: string, wrapsSet: boolean);
    /**
    * @param index the index of the item to return
    */
    get(index: number): DataMongodbatlasResourcePoliciesResultsOutputReference;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.37.0/docs/data-sources/resource_policies mongodbatlas_resource_policies}
*/
export declare class DataMongodbatlasResourcePolicies extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_resource_policies";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasResourcePolicies resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasResourcePolicies to import
    * @param importFromId The id of the existing DataMongodbatlasResourcePolicies that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.37.0/docs/data-sources/resource_policies#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasResourcePolicies to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.37.0/docs/data-sources/resource_policies mongodbatlas_resource_policies} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasResourcePoliciesConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasResourcePoliciesConfig);
    private _orgId?;
    get orgId(): string;
    set orgId(value: string);
    get orgIdInput(): string | undefined;
    private _resourcePolicies;
    get resourcePolicies(): DataMongodbatlasResourcePoliciesResourcePoliciesList;
    private _results;
    get results(): DataMongodbatlasResourcePoliciesResultsList;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
