/**
 * Copyright (c) HashiCorp, Inc.
 * SPDX-License-Identifier: MPL-2.0
 */
import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
export interface DataMongodbatlasThirdPartyIntegrationConfig extends cdktf.TerraformMetaArguments {
    /**
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.37.0/docs/data-sources/third_party_integration#project_id DataMongodbatlasThirdPartyIntegration#project_id}
    */
    readonly projectId: string;
    /**
    * Third-party service integration identifier
    *
    * Docs at Terraform Registry: {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.37.0/docs/data-sources/third_party_integration#type DataMongodbatlasThirdPartyIntegration#type}
    */
    readonly type: string;
}
/**
* Represents a {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.37.0/docs/data-sources/third_party_integration mongodbatlas_third_party_integration}
*/
export declare class DataMongodbatlasThirdPartyIntegration extends cdktf.TerraformDataSource {
    static readonly tfResourceType = "mongodbatlas_third_party_integration";
    /**
    * Generates CDKTF code for importing a DataMongodbatlasThirdPartyIntegration resource upon running "cdktf plan <stack-name>"
    * @param scope The scope in which to define this construct
    * @param importToId The construct id used in the generated config for the DataMongodbatlasThirdPartyIntegration to import
    * @param importFromId The id of the existing DataMongodbatlasThirdPartyIntegration that should be imported. Refer to the {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.37.0/docs/data-sources/third_party_integration#import import section} in the documentation of this resource for the id to use
    * @param provider? Optional instance of the provider where the DataMongodbatlasThirdPartyIntegration to import is found
    */
    static generateConfigForImport(scope: Construct, importToId: string, importFromId: string, provider?: cdktf.TerraformProvider): cdktf.ImportableResource;
    /**
    * Create a new {@link https://registry.terraform.io/providers/mongodb/mongodbatlas/1.37.0/docs/data-sources/third_party_integration mongodbatlas_third_party_integration} Data Source
    *
    * @param scope The scope in which to define this construct
    * @param id The scoped construct ID. Must be unique amongst siblings in the same scope
    * @param options DataMongodbatlasThirdPartyIntegrationConfig
    */
    constructor(scope: Construct, id: string, config: DataMongodbatlasThirdPartyIntegrationConfig);
    get accountId(): string;
    get apiKey(): string;
    get channelName(): string;
    get enabled(): cdktf.IResolvable;
    get id(): string;
    get microsoftTeamsWebhookUrl(): string;
    private _projectId?;
    get projectId(): string;
    set projectId(value: string);
    get projectIdInput(): string | undefined;
    get region(): string;
    get routingKey(): string;
    get secret(): string;
    get sendCollectionLatencyMetrics(): cdktf.IResolvable;
    get sendDatabaseMetrics(): cdktf.IResolvable;
    get serviceDiscovery(): string;
    get serviceKey(): string;
    get teamName(): string;
    private _type?;
    get type(): string;
    set type(value: string);
    get typeInput(): string | undefined;
    get url(): string;
    get userName(): string;
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
    protected synthesizeHclAttributes(): {
        [name: string]: any;
    };
}
